package jp.riken.plot2d.data;

import java.io.*;
import java.util.zip.*;

public abstract class DataFileReader {

    protected BufferedReader openReader(File file) throws IOException {
        InputStream stream = new FileInputStream(file);
        if (file.getName().endsWith(".gz")) {
            stream = new GZIPInputStream(stream);
        }
        return new BufferedReader(new InputStreamReader(stream));
    }

    protected void closeReader(BufferedReader reader) {
        try {
            reader.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    protected String getQuotedValue(String s, String defaultValue) {
        String[] strAry = s.split("\"");
        return (strAry.length > 1) ? strAry[1] : defaultValue;
    }

    protected int toInt(String s, int defaultValue) {
        try {
            return Integer.parseInt(s);
        } catch (NumberFormatException e) {
            return defaultValue;
        }
    }
}
