package jp.riken.plot2d.gui;

import jp.riken.plot2d.data.*;
import jp.riken.plot2d.renderer.*;

public class MousePickHandler {

    private RenderingContext context;

    public MousePickHandler(RenderingContext context) {
        this.context = context;
    }

    public Float picked(int x, int y, PlotData data) {
        double x1 = context.getImageInitX();
        double x2 = context.getImageTermX();
        double y1 = context.getImageInitY();
        double y2 = context.getImageTermY();
        double h = context.getHeight();
        if (x < x1 || x > x2 || y < h - y2 || y > h - y1) {
            return null;
        }
        double minX = data.getLabelGrid().getMinX();
        double maxX = data.getLabelGrid().getMaxX();
        double sx = (x2 - x1) / (maxX - minX);
        float xc = (float) ((x - x1)/ sx + minX);
        data.picked(xc);
        return data.getPickValueX();
    }
}
