package jp.riken.plot2d.gui;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

public class PlotPanel extends JPanel implements MouseListener {

    private static final long serialVersionUID = 1L;

    private GuiController guiController;
    private BufferedImage image;

    private long ticks;
    private static final long CLICK_INTERVAL = 500; // 0.5 second

    public PlotPanel(GuiController guiController) {
        this.guiController = guiController;
        addMouseListener(this);
        setBackground(Color.WHITE);
    }

    public void setImage(BufferedImage image) {
        this.image = image;
    }

    public void paint(Graphics g) {
        super.paint(g);
        g.drawImage(image, 0, 0, this);
    }
    // --------------------------------------------------------------------
    // implements MouseListener
    // --------------------------------------------------------------------
    public void mouseClicked(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mousePressed(MouseEvent e) {
        handleMousePressed(e);
    }

    public void mouseReleased(MouseEvent e) {
        handleMouseReleased(e);
    }

    // --------------------------------------------------------------------
    // handle mouse event
    // --------------------------------------------------------------------
    private void handleMousePressed(MouseEvent e) {
        if (e.getModifiersEx() == MouseEvent.BUTTON1_DOWN_MASK) {
            ticks = System.currentTimeMillis();
        }
    }

    private void handleMouseReleased(MouseEvent e) {
        if (System.currentTimeMillis() - ticks < CLICK_INTERVAL) {
            guiController.mousePicked(e.getX(), e.getY());
        }
    }
}
