package jp.riken.viewer.gui;

import java.awt.*;
import javax.swing.*;
import org.pdbj.viewer.gui.*;

public class CommandFrame extends JFrame {

    private static final long serialVersionUID = 1L;

    private CommandArea commandArea;

    public CommandFrame(CommandArea commandArea) {
        this.commandArea = commandArea;
        setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
        setSize(500, 300);
        createComponent();
    }

    public void setCenterTo(Component owner) {
        Point ownerLocation = owner.getLocation();
        Dimension ownerSize = owner.getSize();
        Dimension size = getSize();
        setLocation(
                ownerLocation.x + (ownerSize.width - size.width) / 2,
                ownerLocation.y + (ownerSize.height - size.height) / 2);
    }

    private void createComponent() {
        Container container = getContentPane();
        container.setLayout(new BorderLayout());
        container.add(commandArea, BorderLayout.CENTER);
    }
}
